HDU 2795 Billboard【线段树】单点查找更新

来源:互联网 发布:mac应用程序根目录 编辑:程序博客网 时间:2024/06/13 10:50

Billboard

Time Limit: 20000/8000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 16533 Accepted Submission(s): 6993


Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.

Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.

Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.

Sample Input
3 5 5
2
4
3
3
3

Sample Output
1
2
3
1
-1


一张公告板,高为h,宽为w,现在需要按次序贴上高度均为1,长度值已知的一些公告,而且每个公告尽量靠上和靠左贴,输出每个公告贴在公告板的第几行


研究了很久,才发现用线段树的做法,因为高度都一样,那么直接把每个高度都当成一个位置,然后每一行当成一个数,贴在某一行的话,当前行对应的数就要减去相应的宽度

然后就是线段树区间最大的模板了........

因为自己递归控制的不够好,就用全局标记变量来做了......

然后再看,发现h 的值好大......看了大神的代码,才醒悟过来...如果h 比n 大的时候,那么最多只需要n 行就够了....也就是h=n....


#include<stdio.h>#include<algorithm>using namespace std;int mtree[1000005],kase,k;//kase 标记是否贴上的状态,k 记录贴上的位置void build(int rt,int l,int r,int res){if(l==r){mtree[rt]=res;return ;}int mid=(l+r)>>1,tp=rt<<1;build(tp,l,mid,res);build(tp|1,mid+1,r,res);mtree[rt]=max(mtree[tp],mtree[tp|1]);}void find(int rt,int l,int r,int res){if(kase||mtree[rt]<res){if(rt==1){k=-1;}return;}if(l==r){mtree[rt]-=res;k=r;kase=1;return;}int mid=(l+r)>>1,tp=rt<<1;find(tp,l,mid,res);find(tp|1,mid+1,r,res);mtree[rt]=max(mtree[tp],mtree[tp|1]); }int main(){int h,w,n,x;//freopen("shuju.txt","r",stdin);while(~scanf("%d%d%d",&h,&w,&n)){if(h>n){h=n;}build(1,1,h,w);for(int i=0;i<n;++i){scanf("%d",&x);kase=0;find(1,1,h,x);printf("%d\n",k);}}return 0;}


0 0
原创粉丝点击